<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\SstOcorrencia;
use Folha\Entities\SstVitima;
use Folha\Entities\SstVitimaparteatingida;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;

class OcorrenciaService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteOcorrencia($dataset) {
        
        $nrorg = $dataset["NRORG"];
        $nrocorrencia = $dataset["NROCORRENCIA"];
        $vitima = SstVitima::findByNrocorrenciaAndNrorg($nrocorrencia, $nrorg);
        if (isset($vitima[0])) {
            throw new \Exception(Messages::HCM05000_SST_OCORRENCIA_EXISTS_VITIMA_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $ocorrencia = SstOcorrencia::findOneByNrocorrenciaAndNrorg($nrocorrencia, $nrorg);
            $this->entityManager->remove($ocorrencia);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
    
    public function deleteVitima($dataset) {
        $nrorg = $dataset["NRORG"];
        $nrvitima = $dataset["NRVITIMA"];
        $parteatingida = SstVitimaparteatingida::findByNrvitimaAndNrorg($nrvitima, $nrorg);
        if (isset($parteatingida[0])) {
            throw new \Exception(Messages::HCM05000_SST_VITIMA_EXISTS_PARTEATING_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $vitima = SstVitima::findOneByNrvitimaAndNrorg($nrvitima, $nrorg);
            $this->entityManager->remove($vitima);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}