IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SETORPRODUTOFIL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SETORPRODUTOFIL
GO

CREATE TRIGGER DTULTATU_SETORPRODUTOFIL
ON SETORPRODUTOFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SETORPRODUTOFIL', '', 'CDPRODUTO='+CDPRODUTO+';CDSETOR='+CDSETOR+';CDFILIAL='+CDFILIAL+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SETORPRODUTOFIL
         SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
        FROM INSERTED
       WHERE (ISNULL(SETORPRODUTOFIL.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0))
         AND (ISNULL(SETORPRODUTOFIL.CDSETOR  ,0) = ISNULL(INSERTED.CDSETOR  ,0))
         AND (ISNULL(SETORPRODUTOFIL.CDFILIAL ,0) = ISNULL(INSERTED.CDFILIAL ,0));
   END;
END;
GO

UPDATE SETORPRODUTOFIL SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUSETORPRODUTOFIL' and
            type = 'D')
   ALTER TABLE SETORPRODUTOFIL DROP CONSTRAINT DEFAULT_DTULTATUSETORPRODUTOFIL
GO

ALTER TABLE SETORPRODUTOFIL ADD CONSTRAINT DEFAULT_DTULTATUSETORPRODUTOFIL
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SETORPRODUTOFIL','5.85.000';
GO